// test_timesec.cpp
// Glenn G. Chappell
// 1 Oct 2013
//
// For CS 202 Fall 2013
// Test program for class TimeSec:
// operators += binary+

#include "timesec.h"  // For class TimeSec
#include "timesec.h"  // Double-inclusion test

#include <iostream>
using std::cout;
using std::endl;
using std::cin;
#include <string>
using std::string;
#include <sstream>
using std::ostringstream;


bool allGood = true;  // true if all tests pass so far


// testTimeSec_basic
// Test for class TimeSec: construction & print
// Prints results of tests, sets global allGood to false if any fail
void testTimeSec_basic()
{
    cout << endl;
    cout << "Test: construction & print" << endl;

    {
    TimeSec t;
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 0:00:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(5);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 5:00:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(12);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = "12:00:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(3, 25);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 3:25:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(3, 5);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 3:05:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(11, 5, 16);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = "11:05:16";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(3, 5, 6);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 3:05:06";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }
}


// testTimeSec_addassign
// Test for class TimeSec: addition-assignment
// Prints results of tests, sets global allGood to false if any fail
void testTimeSec_addassign()
{
    cout << endl;
    cout << "Test: \"+=\" operator" << endl;

    {
    TimeSec t(1,2,3);
    t += 20;
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 1:02:23";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(1,2,3);
    t += 62;
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 1:03:05";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(1,59,3);
    t += 62;
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 2:00:05";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(23,59,3);
    t += 62;
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 0:00:05";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(4,23,37);
    t += 100000;
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 8:10:17";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }
}




// testTimeSec_addition
// Test for class TimeSec: addition
// Prints results_addition()
void testTimeSec_addition()
{
    cout << endl;
    cout << "Test: \"+\" operator" << endl;

    {
    TimeSec t(1,2,3);
    TimeSec t2 = t + 20;
    ostringstream os;
    t2.print(os);
    string s = os.str();
    string ans = " 1:02:23";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(1,2,3);
    TimeSec t2 = t + 62;
    ostringstream os;
    t2.print(os);
    string s = os.str();
    string ans = " 1:03:05";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(1,59,3);
    TimeSec t2 = t + 62;
    ostringstream os;
    t2.print(os);
    string s = os.str();
    string ans = " 2:00:05";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(23,59,3);
    TimeSec t2 = t + 62;
    ostringstream os;
    t2.print(os);
    string s = os.str();
    string ans = " 0:00:05";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(4,23,37);
    TimeSec t2 = t + 100000;
    ostringstream os;
    t2.print(os);
    string s = os.str();
    string ans = " 8:10:17";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }
}


// main program
// Runs tests for class TimeSec, prints results
int main()
{
    testTimeSec_basic();
    testTimeSec_addassign();
    testTimeSec_addition();
    
    cout << endl;
    if (allGood)
        cout << "All tests pass!" << endl;
    else
        cout << "***** SOME TESTS FAILED *****" << endl;

    cout << endl;
    cout << "Press ENTER to quit ";
    while (cin.get() != '\n') ;

    return 0;
}

